## RiskyMod
A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well. Nearly every change from this mod can be toggled on/off, so you can configure it to your liking!

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found at https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority.

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

**Contact me if you're interested in translating the mod!**

## Main Features

- Oneshot Protection now actually works.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage stacking.
	- Most forms of range scaling have been removed, and most items aren't able to proc chain anymore.
- Big balance pass over all the Survivors
	- Less useless skill options, default Commando is good now!
- Drone performance now remains the same on all stages.

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- Make Google Doc more readable/pretty.
	- Split up into multiple separate docs?
- Tweak enemy pools

*Mostly done with everything I've wanted to do with the mod. Plan going forward is to iron out the existing balance. There's some items that I don't like but don't have any ideas for reworking, so I'll list them here and leave it up to you on whether you want to enable them in your runs.*

- Items I don't like but don't want to touch either:
	- Roll of Pennies
	- Lost Seer's Lens 
	- Regenerating Scrap
	- Executive Card
	
## For Developers

To make custom allies compatible with RiskyMod's ally changes, use these items located in AllyItems.cs:

- AllyMarkerItem makes the holder benefit from Ally damage resistances. No effect when stacked.
- AllyScalingItem changes level scaling from +30% HP +20% damage -> +20% HP +30% damage so that allies perform the same on all stages. No effect when stacked.
- AllyRegenItem makes the holder's HP regenerate to full in X seconds, X being the amount of stacks.
- AllyAllowVoidDeathItem makes the holder to bypass the "No Void Death" config option.
- AllyAllowOverheatDeathItem makes the holder to bypass the "No Overheat" config option.
- AllyResistAoEItem enables the ResistantToAoE bodyflag on the holder, granting them +300 armor against attacks with DamageType.AoE

These are always initialized even if Ally changes are disabled and their effects have config-checking built-in, so you can simply add them to your allies without having to worry about anything.

Make sure these are only given to Player-team allies, since they'll be painful to fight against (in a bad/unintuitive way) when they're given to enemies.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp Distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM, VALE-X

## Changelog

*Full changelog included in the .zip*

`0.14.7`

- Defensive Microbots Deletion Restrictions
	- Now checks if projectile speed > 0 before deleting, so that things like the moon escape explosions don't get deleted.

`0.14.6`

- Allies
	- Added Tinkers Satchel support.

`0.14.5`

- Allies
	- Damage Zone Resistance (previously Mushrum Resistance)
		- Now includes Lunar Exploder fire pools.
	- AllyRegenItem now scales with internal BoostHP items.
		- This will fix certain allies having really slow health regen.
		
- Items
	- Transcendence
		- Increased shield regen penalty from 0 (+0.5s) -> 0 (+1s)
		- Transcendence shieldgating is now a separate config option from the global shieldgating setting.
			- Located in RiskyMod_Items.cfg next to the Transcendence config option.
			- If enabled, Transcendence will shield gate even if Shield Gating is disabled.
			- If disabled, it will simply follow whatever setting Shield Gating is set to.
			
		*Putting this at a halfway point between the earlier 1s (+1s) value and the 0 (+0.5s) value.*
			
- Enemies
	- Stone Titan
		- Increased laser radius from 0 -> 0.2
		
		*Nerfs from previous updates made these a bit too ineffective at using their laser.*

`0.14.4`

- Railgunner
	- Fixed Bungus knockback fix not working online (and causing console spam).

`0.14.3`

- Commando
	- Reduced Phase Round damage from 480%/240% -> 450%/150%
	
- Allies
	- Added support for SS2's Security Drones, Spikestrip's Blue Lemurian, Chill Drone, QB Drone, and Gradius Mod.
		- Compat can be enabled/disabled in the config.

`0.14.2`

- Added Disable Projectile On-Kill Effects config option for Vagrants, Grovetenders, and Lunar Wisps in RiskyMod_Enemies.cfg
	- Prevents players from proccing on kill effects when shooting down projectiles from the above enemies.
		- This was already in the mod beforehand, but was tied to the other changes for each monster and couldn't be independently enabled/disabled.

`0.14.1`

- Fixed Vengeance Nkuhanas Opinion damage reduction not working.
- Fixed Void Locus Void Potentials being able to have duplicate item choices.
- Fixed Zoea Ignore Ally Cap config option causing Zoea allies to not benefit from ally changes when disabled.
- Internal ally bonus items are now disabled when KingKombatArena is active.
- Squid Polyps have -75% HP when spawned by enemies or when spawned in KingKombatArena

`0.14.0`

- Fixed missing DirectorAPI dependency causing the mod to not work on certain modpacks.
	- Bug probably showed up around 0.13.24 or 0.13.25
	
- Items that fall out of bounds are now teleported back into the stage.
	- Slightly jank, condition for triggering is item lifetime > 10s and item velocity > 5m/s.
	- Config option is located in the Misc section of RiskyMod_General.cfg
	
- Homing projectiles now select targets based on angle, instead of angle + distance.
	- This will make all homing projectiles more reliable at actually hitting their target, instead of suddenly curving off to the side and missing.
		- Notably affects Visions of Heresy.
	- Config option is located in the Misc section of RiskyMod_General.cfg
	
- Void Locus
	- Signals Drop Items
		- Removed Pearl/Lunar drop chance config option.
		- Reduced Common chance from 50% -> 45%
		- Reduced Legendary chance from 10% -> 5%
		- Now has a 10% chance to drop Void items.
		- Now drops Void Potentials.
		
		*You will need to manually change the chance config if you are updating.*

- Artificer
	- Fixed Utility self-knockback applying while grounded.
	
- Items
	- Aegis
		- Stacks no longer increase overheal->barrier percent beyond the initial 50%.
		- Now divides barrier decay rate by 2 (+1 per stack)
			
		*Should give this item a much more tangible benefit. Leaving the base overheal->barrier percent alone for now to gauge how effective this item is in its current state.*
		
	- Brittle Crown
		- Changed damage coefficient scaling range from 100%-1000% -> 200%-1200%
		
	- Needletick
		- Disabled changes.
		
		*The -1 armor did nothing to actually help the item in MP/loops, and just bloated the item's functionality. Will only re-enable changes if I actually have something that works.*
		
	- Newly-Hatched Zoea
		- Disabled in Bazaar.
		- Reduced max ally count from 8 -> 6
		- Max ally count can now be specified in config.
		
- Enemies
	- Stone Titan
		- Disabled laser duration extension change.
		
		*Was annoying to fight at midrange, and made them worse at close range due to being committed to lasering for longer.*